Index: branches/ODCCP/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp
===================================================================
--- branches/ODCCP/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 492)
+++ branches/ODCCP/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 494)
@@ -7610,7 +7412,7 @@
           break;
 
-      //////////////////////////
+      ////////////////////////
       case ALLOC_IVT_XRAM_RSP:         // allocated to XRAM_RSP FSM
-          if(r_xram_rsp_fsm.read() != XRAM_RSP_INVAL_LOCK)
+          if(r_xram_rsp_fsm.read() != XRAM_RSP_IVT_LOCK)
           {
             if(r_cleanup_fsm.read() == CLEANUP_IVT_LOCK)
@@ -7620,5 +7422,5 @@
               r_alloc_ivt_fsm = ALLOC_IVT_CAS;
 
-            else if (r_config_fsm.read() == CONFIG_DIR_IVT_LOCK)
+            else if (r_config_fsm.read() == CONFIG_IVT_LOCK)
               r_alloc_ivt_fsm = ALLOC_IVT_CONFIG;
 
@@ -7631,5 +7433,5 @@
           break;
 
-      //////////////////////////
+      ///////////////////////
       case ALLOC_IVT_CLEANUP:          // allocated to CLEANUP FSM
           if ((r_cleanup_fsm.read() != CLEANUP_IVT_LOCK     ) and
@@ -7639,5 +7441,5 @@
               r_alloc_ivt_fsm = ALLOC_IVT_CAS;
 
-            else if (r_config_fsm.read() == CONFIG_DIR_IVT_LOCK)
+            else if (r_config_fsm.read() == CONFIG_IVT_LOCK)
               r_alloc_ivt_fsm = ALLOC_IVT_CONFIG;
 
@@ -7645,9 +7447,6 @@
               r_alloc_ivt_fsm = ALLOC_IVT_WRITE;
 
-            else if (r_xram_rsp_fsm.read() == XRAM_RSP_INVAL_LOCK)
+            else if (r_xram_rsp_fsm.read() == XRAM_RSP_IVT_LOCK)
               r_alloc_ivt_fsm = ALLOC_IVT_XRAM_RSP;
-
-            else
-              m_cpt_ivt_unused++;
           }
           break;
@@ -7657,5 +7456,5 @@
           if (r_cas_fsm.read() != CAS_BC_IVT_LOCK)
           {
-            if (r_config_fsm.read() == CONFIG_DIR_IVT_LOCK)
+            if (r_config_fsm.read() == CONFIG_IVT_LOCK)
               r_alloc_ivt_fsm = ALLOC_IVT_CONFIG;
 
@@ -7663,5 +7462,5 @@
               r_alloc_ivt_fsm = ALLOC_IVT_WRITE;
 
-            else if (r_xram_rsp_fsm.read() == XRAM_RSP_INVAL_LOCK)
+            else if (r_xram_rsp_fsm.read() == XRAM_RSP_IVT_LOCK)
               r_alloc_ivt_fsm = ALLOC_IVT_XRAM_RSP;
 
@@ -7669,6 +7468,4 @@
               r_alloc_ivt_fsm = ALLOC_IVT_CLEANUP;
       
-            else
-              m_cpt_ivt_unused++;
           }
           break;
@@ -7676,10 +7473,10 @@
       //////////////////////////
       case ALLOC_IVT_CONFIG:           // allocated to CONFIG FSM
-          if (r_config_fsm.read() != CONFIG_DIR_IVT_LOCK)
+          if (r_config_fsm.read() != CONFIG_IVT_LOCK)
           {
             if (r_write_fsm.read() == WRITE_BC_IVT_LOCK)
               r_alloc_ivt_fsm = ALLOC_IVT_WRITE;
 
-            else if (r_xram_rsp_fsm.read() == XRAM_RSP_INVAL_LOCK)
+            else if (r_xram_rsp_fsm.read() == XRAM_RSP_IVT_LOCK)
               r_alloc_ivt_fsm = ALLOC_IVT_XRAM_RSP;
 
@@ -7690,6 +7487,4 @@
               r_alloc_ivt_fsm = ALLOC_IVT_CAS;
           
-            else
-              m_cpt_ivt_unused++;
           }
           break;
@@ -7706,4 +7501,6 @@
   /////////////////////////////////////////////////////////////////////////////////////
 
+//std::cout << std::endl << "alloc_dir_fsm" << std::endl;
+
   switch(r_alloc_dir_fsm.read())
   {
@@ -7725,5 +7522,7 @@
     if ( (r_config_fsm.read()    != CONFIG_DIR_REQ) and
          (r_config_fsm.read()    != CONFIG_DIR_ACCESS) and
-         (r_config_fsm.read()    != CONFIG_DIR_IVT_LOCK) )
+         (r_config_fsm.read()    != CONFIG_TRT_LOCK) and
+         (r_config_fsm.read()    != CONFIG_TRT_SET) and
+         (r_config_fsm.read()    != CONFIG_IVT_LOCK) )
     {
         if(r_read_fsm.read() == READ_DIR_REQ)
@@ -7780,5 +7579,5 @@
     if(((r_write_fsm.read()       != WRITE_DIR_REQ)  and
         (r_write_fsm.read()       != WRITE_DIR_LOCK)  and
-        (r_write_fsm.read()       != WRITE_DIR_READ)  and
+        (r_write_fsm.read()       != WRITE_BC_DIR_READ)  and
         (r_write_fsm.read()       != WRITE_DIR_HIT)  and
         (r_write_fsm.read()       != WRITE_BC_TRT_LOCK)  and
@@ -7890,5 +7689,5 @@
     if( (r_xram_rsp_fsm.read() != XRAM_RSP_DIR_LOCK) and
         (r_xram_rsp_fsm.read() != XRAM_RSP_TRT_COPY) and
-        (r_xram_rsp_fsm.read() != XRAM_RSP_INVAL_LOCK))
+        (r_xram_rsp_fsm.read() != XRAM_RSP_IVT_LOCK))
     {
         if(r_config_fsm.read() == CONFIG_DIR_REQ)
@@ -7920,17 +7719,277 @@
   ////////////////////////////////////////////////////////////////////////////////////
   // The ALLOC_TRT fsm allocates the access to the Transaction Table (write buffer)
-  // with a round robin priority between 4 user FSMs :
-  // The cyclic priority is READ > WRITE > CAS > XRAM_RSP
+  // with a round robin priority between 7 user FSMs :
+  // The priority is READ > WRITE > CAS > IXR_CMD > XRAM_RSP > IXR_RSP > CONFIG
   // The ressource is always allocated.
   ///////////////////////////////////////////////////////////////////////////////////
 
+//std::cout << std::endl << "alloc_trt_fsm" << std::endl;
+
   switch(r_alloc_trt_fsm.read())
   {
-    ////////////////////
-    case ALLOC_TRT_READ:
-      if(r_read_fsm.read() != READ_TRT_LOCK)
-      {
-        if((r_write_fsm.read() == WRITE_MISS_TRT_LOCK) or
-            (r_write_fsm.read() == WRITE_BC_TRT_LOCK))
+      ////////////////////
+      case ALLOC_TRT_READ:
+          if(r_read_fsm.read() != READ_TRT_LOCK)
+          {
+              if((r_write_fsm.read() == WRITE_MISS_TRT_LOCK) or
+                  (r_write_fsm.read() == WRITE_BC_TRT_LOCK))
+                  r_alloc_trt_fsm = ALLOC_TRT_WRITE;
+
+              else if((r_cas_fsm.read() == CAS_MISS_TRT_LOCK) or
+                      (r_cas_fsm.read() == CAS_BC_TRT_LOCK))
+                  r_alloc_trt_fsm = ALLOC_TRT_CAS;
+
+              else if((r_ixr_cmd_fsm.read() == IXR_CMD_READ_TRT) or
+                      (r_ixr_cmd_fsm.read() == IXR_CMD_WRITE_TRT) or
+                      (r_ixr_cmd_fsm.read() == IXR_CMD_CAS_TRT) or
+                      (r_ixr_cmd_fsm.read() == IXR_CMD_XRAM_TRT) or
+                      (r_ixr_cmd_fsm.read() == IXR_CMD_CLEANUP_TRT) or
+                      (r_ixr_cmd_fsm.read() == IXR_CMD_CONFIG_TRT) )
+                  r_alloc_trt_fsm = ALLOC_TRT_IXR_CMD;
+
+              else if((r_xram_rsp_fsm.read()  == XRAM_RSP_DIR_LOCK) and
+                      (r_alloc_dir_fsm.read() == ALLOC_DIR_XRAM_RSP))
+                  r_alloc_trt_fsm = ALLOC_TRT_XRAM_RSP;
+
+              else if((r_ixr_rsp_fsm.read() == IXR_RSP_TRT_ERASE) or
+                      (r_ixr_rsp_fsm.read() == IXR_RSP_TRT_READ))
+                  r_alloc_trt_fsm = ALLOC_TRT_IXR_RSP;
+
+              else if( r_config_fsm.read() == CONFIG_TRT_LOCK ) 
+                  r_alloc_trt_fsm = ALLOC_TRT_CONFIG;
+              
+              else if (r_cleanup_fsm.read() == CLEANUP_IXR_REQ)
+                r_alloc_trt_fsm = ALLOC_TRT_CLEANUP;
+          }
+          break;
+
+      /////////////////////
+      case ALLOC_TRT_WRITE:
+          if((r_write_fsm.read() != WRITE_MISS_TRT_LOCK) and
+             (r_write_fsm.read() != WRITE_BC_TRT_LOCK) and
+             (r_write_fsm.read() != WRITE_BC_IVT_LOCK))
+          {
+              if((r_cas_fsm.read() == CAS_MISS_TRT_LOCK) or
+                 (r_cas_fsm.read() == CAS_BC_TRT_LOCK))
+                  r_alloc_trt_fsm = ALLOC_TRT_CAS;
+
+              else if((r_ixr_cmd_fsm.read() == IXR_CMD_READ_TRT) or
+                      (r_ixr_cmd_fsm.read() == IXR_CMD_WRITE_TRT) or
+                      (r_ixr_cmd_fsm.read() == IXR_CMD_CAS_TRT) or
+                      (r_ixr_cmd_fsm.read() == IXR_CMD_XRAM_TRT) or
+                      (r_ixr_cmd_fsm.read() == IXR_CMD_CLEANUP_TRT) or
+                      (r_ixr_cmd_fsm.read() == IXR_CMD_CONFIG_TRT) )
+                  r_alloc_trt_fsm = ALLOC_TRT_IXR_CMD;
+
+              else if((r_xram_rsp_fsm.read()  == XRAM_RSP_DIR_LOCK) and
+                      (r_alloc_dir_fsm.read() == ALLOC_DIR_XRAM_RSP))
+                  r_alloc_trt_fsm = ALLOC_TRT_XRAM_RSP;
+
+              else if((r_ixr_rsp_fsm.read() == IXR_RSP_TRT_ERASE) or
+                      (r_ixr_rsp_fsm.read() == IXR_RSP_TRT_READ))
+                  r_alloc_trt_fsm = ALLOC_TRT_IXR_RSP;
+
+              else if( r_config_fsm.read() == CONFIG_TRT_LOCK ) 
+                  r_alloc_trt_fsm = ALLOC_TRT_CONFIG;
+              
+              else if (r_cleanup_fsm.read() == CLEANUP_IXR_REQ)
+                r_alloc_trt_fsm = ALLOC_TRT_CLEANUP;
+ 
+              else if(r_read_fsm.read() == READ_TRT_LOCK)
+                  r_alloc_trt_fsm = ALLOC_TRT_READ;
+          }
+          break;
+      ///////////////////
+      case ALLOC_TRT_CAS:
+          if((r_cas_fsm.read() != CAS_MISS_TRT_LOCK) and
+             (r_cas_fsm.read() != CAS_BC_TRT_LOCK) and
+             (r_cas_fsm.read() != CAS_BC_IVT_LOCK))
+          {
+              if((r_ixr_cmd_fsm.read() == IXR_CMD_READ_TRT) or
+                 (r_ixr_cmd_fsm.read() == IXR_CMD_WRITE_TRT) or
+                 (r_ixr_cmd_fsm.read() == IXR_CMD_CAS_TRT) or
+                 (r_ixr_cmd_fsm.read() == IXR_CMD_XRAM_TRT) or
+                 (r_ixr_cmd_fsm.read() == IXR_CMD_CLEANUP_TRT) or
+                 (r_ixr_cmd_fsm.read() == IXR_CMD_CONFIG_TRT) )
+                  r_alloc_trt_fsm = ALLOC_TRT_IXR_CMD;
+
+              if((r_xram_rsp_fsm.read()  == XRAM_RSP_DIR_LOCK) and
+                 (r_alloc_dir_fsm.read() == ALLOC_DIR_XRAM_RSP))
+                  r_alloc_trt_fsm = ALLOC_TRT_XRAM_RSP;
+
+              else if((r_ixr_rsp_fsm.read() == IXR_RSP_TRT_ERASE) or
+                      (r_ixr_rsp_fsm.read() == IXR_RSP_TRT_READ))
+                  r_alloc_trt_fsm = ALLOC_TRT_IXR_RSP;
+
+              else if( r_config_fsm.read() == CONFIG_TRT_LOCK ) 
+                  r_alloc_trt_fsm = ALLOC_TRT_CONFIG;
+              
+              else if (r_cleanup_fsm.read() == CLEANUP_IXR_REQ)
+                r_alloc_trt_fsm = ALLOC_TRT_CLEANUP;
+
+              else if(r_read_fsm.read() == READ_TRT_LOCK)
+                  r_alloc_trt_fsm = ALLOC_TRT_READ;
+
+              else if((r_write_fsm.read() == WRITE_MISS_TRT_LOCK) or
+                      (r_write_fsm.read() == WRITE_BC_TRT_LOCK))
+                  r_alloc_trt_fsm = ALLOC_TRT_WRITE;
+          }
+          break;
+      ///////////////////////
+      case ALLOC_TRT_IXR_CMD:
+          if((r_ixr_cmd_fsm.read() != IXR_CMD_READ_TRT) and
+             (r_ixr_cmd_fsm.read() != IXR_CMD_WRITE_TRT) and
+             (r_ixr_cmd_fsm.read() != IXR_CMD_CAS_TRT) and
+             (r_ixr_cmd_fsm.read() != IXR_CMD_XRAM_TRT) and
+             (r_ixr_cmd_fsm.read() != IXR_CMD_CLEANUP_TRT) and
+             (r_ixr_cmd_fsm.read() != IXR_CMD_CONFIG_TRT))
+          {
+              if((r_xram_rsp_fsm.read()  == XRAM_RSP_DIR_LOCK) and
+                 (r_alloc_dir_fsm.read() == ALLOC_DIR_XRAM_RSP))
+                  r_alloc_trt_fsm = ALLOC_TRT_XRAM_RSP;
+
+              else if((r_ixr_rsp_fsm.read() == IXR_RSP_TRT_ERASE) or
+                      (r_ixr_rsp_fsm.read() == IXR_RSP_TRT_READ))
+                  r_alloc_trt_fsm = ALLOC_TRT_IXR_RSP;
+
+              else if( r_config_fsm.read() == CONFIG_TRT_LOCK ) 
+                  r_alloc_trt_fsm = ALLOC_TRT_CONFIG;
+              
+              else if (r_cleanup_fsm.read() == CLEANUP_IXR_REQ)
+                r_alloc_trt_fsm = ALLOC_TRT_CLEANUP;
+
+              else if(r_read_fsm.read() == READ_TRT_LOCK)
+                  r_alloc_trt_fsm = ALLOC_TRT_READ;
+
+              else if((r_write_fsm.read() == WRITE_MISS_TRT_LOCK) or
+                      (r_write_fsm.read() == WRITE_BC_TRT_LOCK))
+                  r_alloc_trt_fsm = ALLOC_TRT_WRITE;
+
+              else if((r_cas_fsm.read() == CAS_MISS_TRT_LOCK) or
+                      (r_cas_fsm.read() == CAS_BC_TRT_LOCK))
+                  r_alloc_trt_fsm = ALLOC_TRT_CAS;
+          }
+          break;
+      ////////////////////////
+      case ALLOC_TRT_XRAM_RSP:
+          if(((r_xram_rsp_fsm.read()  != XRAM_RSP_DIR_LOCK)  or
+              (r_alloc_dir_fsm.read() != ALLOC_DIR_XRAM_RSP)) and
+              (r_xram_rsp_fsm.read()  != XRAM_RSP_TRT_COPY)  and
+              (r_xram_rsp_fsm.read()  != XRAM_RSP_DIR_UPDT)  and
+              (r_xram_rsp_fsm.read()  != XRAM_RSP_IVT_LOCK))
+          {
+              if((r_ixr_rsp_fsm.read() == IXR_RSP_TRT_ERASE) or
+                 (r_ixr_rsp_fsm.read() == IXR_RSP_TRT_READ))
+                  r_alloc_trt_fsm = ALLOC_TRT_IXR_RSP;
+
+              else if( r_config_fsm.read() == CONFIG_TRT_LOCK ) 
+                  r_alloc_trt_fsm = ALLOC_TRT_CONFIG;
+              
+              else if (r_cleanup_fsm.read() == CLEANUP_IXR_REQ)
+                r_alloc_trt_fsm = ALLOC_TRT_CLEANUP;
+
+              else if(r_read_fsm.read() == READ_TRT_LOCK)
+                  r_alloc_trt_fsm = ALLOC_TRT_READ;
+
+              else if((r_write_fsm.read() == WRITE_MISS_TRT_LOCK) or
+                      (r_write_fsm.read() == WRITE_BC_TRT_LOCK))
+                  r_alloc_trt_fsm = ALLOC_TRT_WRITE;
+
+              else if((r_cas_fsm.read() == CAS_MISS_TRT_LOCK) or
+                      (r_cas_fsm.read() == CAS_BC_TRT_LOCK))
+                  r_alloc_trt_fsm = ALLOC_TRT_CAS;
+
+              else if((r_ixr_cmd_fsm.read() == IXR_CMD_READ_TRT) or
+                      (r_ixr_cmd_fsm.read() == IXR_CMD_WRITE_TRT) or
+                      (r_ixr_cmd_fsm.read() == IXR_CMD_CAS_TRT) or
+                      (r_ixr_cmd_fsm.read() == IXR_CMD_XRAM_TRT) or
+                      (r_ixr_cmd_fsm.read() == IXR_CMD_CLEANUP_TRT) or
+                      (r_ixr_cmd_fsm.read() == IXR_CMD_CONFIG_TRT) )
+                  r_alloc_trt_fsm = ALLOC_TRT_IXR_CMD;
+
+          }
+          break;
+      ///////////////////////
+      case ALLOC_TRT_IXR_RSP:
+          if((r_ixr_rsp_fsm.read() != IXR_RSP_TRT_ERASE) and
+             (r_ixr_rsp_fsm.read() != IXR_RSP_TRT_READ))
+          {
+              if(r_config_fsm.read() == CONFIG_TRT_LOCK)
+                  r_alloc_trt_fsm = ALLOC_TRT_CONFIG;
+              
+              else if (r_cleanup_fsm.read() == CLEANUP_IXR_REQ)
+                r_alloc_trt_fsm = ALLOC_TRT_CLEANUP;
+
+              else if(r_read_fsm.read() == READ_TRT_LOCK)
+                  r_alloc_trt_fsm = ALLOC_TRT_READ;
+
+              else if((r_write_fsm.read() == WRITE_MISS_TRT_LOCK) or
+                      (r_write_fsm.read() == WRITE_BC_TRT_LOCK))
+                  r_alloc_trt_fsm = ALLOC_TRT_WRITE;
+
+              else if((r_cas_fsm.read() == CAS_MISS_TRT_LOCK) or
+                      (r_cas_fsm.read() == CAS_BC_TRT_LOCK))
+                  r_alloc_trt_fsm = ALLOC_TRT_CAS;
+
+              else if((r_ixr_cmd_fsm.read() == IXR_CMD_READ_TRT) or
+                      (r_ixr_cmd_fsm.read() == IXR_CMD_WRITE_TRT) or
+                      (r_ixr_cmd_fsm.read() == IXR_CMD_CAS_TRT) or
+                      (r_ixr_cmd_fsm.read() == IXR_CMD_XRAM_TRT) or
+                      (r_ixr_cmd_fsm.read() == IXR_CMD_CLEANUP_TRT) or
+                      (r_ixr_cmd_fsm.read() == IXR_CMD_CONFIG_TRT) )
+                  r_alloc_trt_fsm = ALLOC_TRT_IXR_CMD;
+
+              else if((r_xram_rsp_fsm.read()  == XRAM_RSP_DIR_LOCK) and
+                      (r_alloc_dir_fsm.read() == ALLOC_DIR_XRAM_RSP))
+                  r_alloc_trt_fsm = ALLOC_TRT_XRAM_RSP;
+          }
+          break;
+      //////////////////////
+      case ALLOC_TRT_CONFIG:
+          if((r_config_fsm.read() != CONFIG_TRT_LOCK) and
+             (r_config_fsm.read() != CONFIG_TRT_SET))
+          {
+              if (r_cleanup_fsm.read() == CLEANUP_IXR_REQ)
+                r_alloc_trt_fsm = ALLOC_TRT_CLEANUP;
+
+              else if(r_read_fsm.read() == READ_TRT_LOCK)
+                  r_alloc_trt_fsm = ALLOC_TRT_READ;
+
+              else if((r_write_fsm.read() == WRITE_MISS_TRT_LOCK) or
+                      (r_write_fsm.read() == WRITE_BC_TRT_LOCK))
+                  r_alloc_trt_fsm = ALLOC_TRT_WRITE;
+
+              else if((r_cas_fsm.read() == CAS_MISS_TRT_LOCK) or
+                      (r_cas_fsm.read() == CAS_BC_TRT_LOCK))
+                  r_alloc_trt_fsm = ALLOC_TRT_CAS;
+
+              else if((r_ixr_cmd_fsm.read() == IXR_CMD_READ_TRT) or
+                      (r_ixr_cmd_fsm.read() == IXR_CMD_WRITE_TRT) or
+                      (r_ixr_cmd_fsm.read() == IXR_CMD_CAS_TRT) or
+                      (r_ixr_cmd_fsm.read() == IXR_CMD_XRAM_TRT) or
+                      (r_ixr_cmd_fsm.read() == IXR_CMD_CLEANUP_TRT) or
+                      (r_ixr_cmd_fsm.read() == IXR_CMD_CONFIG_TRT) )
+                  r_alloc_trt_fsm = ALLOC_TRT_IXR_CMD;
+
+              else if((r_xram_rsp_fsm.read()  == XRAM_RSP_DIR_LOCK) and
+                      (r_alloc_dir_fsm.read() == ALLOC_DIR_XRAM_RSP))
+                  r_alloc_trt_fsm = ALLOC_TRT_XRAM_RSP;
+
+              else if((r_ixr_rsp_fsm.read() == IXR_RSP_TRT_ERASE) or
+                      (r_ixr_rsp_fsm.read() == IXR_RSP_TRT_READ))
+                  r_alloc_trt_fsm = ALLOC_TRT_IXR_RSP;
+
+          }
+          break;
+
+      ////////////////////////
+    case ALLOC_TRT_CLEANUP:
+      if(r_cleanup_fsm.read() != CLEANUP_IXR_REQ)
+      {
+        if(r_read_fsm.read() == READ_TRT_LOCK)
+          r_alloc_trt_fsm = ALLOC_TRT_READ;
+
+        else if((r_write_fsm.read() == WRITE_MISS_TRT_LOCK) or
+                (r_write_fsm.read() == WRITE_BC_TRT_LOCK))
           r_alloc_trt_fsm = ALLOC_TRT_WRITE;
 
@@ -7939,218 +7998,26 @@
           r_alloc_trt_fsm = ALLOC_TRT_CAS;
 
+        else if((r_ixr_cmd_fsm.read() == IXR_CMD_READ_TRT) or
+            (r_ixr_cmd_fsm.read() == IXR_CMD_WRITE_TRT) or
+            (r_ixr_cmd_fsm.read() == IXR_CMD_CAS_TRT) or
+            (r_ixr_cmd_fsm.read() == IXR_CMD_XRAM_TRT) or
+            (r_ixr_cmd_fsm.read() == IXR_CMD_CLEANUP_TRT) or
+            (r_ixr_cmd_fsm.read() == IXR_CMD_CONFIG_TRT) )
+          r_alloc_trt_fsm = ALLOC_TRT_IXR_CMD;
+
         else if((r_xram_rsp_fsm.read()  == XRAM_RSP_DIR_LOCK) and
-                (r_alloc_dir_fsm.read() == ALLOC_DIR_XRAM_RSP))
-          r_alloc_trt_fsm = ALLOC_TRT_XRAM_RSP;
-
-        else if((r_ixr_rsp_fsm.read() == IXR_RSP_TRT_ERASE) or
-                (r_ixr_rsp_fsm.read() == IXR_RSP_TRT_READ))
-          r_alloc_trt_fsm = ALLOC_TRT_IXR_RSP;
-
-        else if (r_cleanup_fsm.read() == CLEANUP_IXR_REQ)
-          r_alloc_trt_fsm = ALLOC_TRT_CLEANUP;
-
-        else if (r_ixr_cmd_fsm.read() == IXR_CMD_TRT_LOCK)
-          r_alloc_trt_fsm = ALLOC_TRT_IXR_CMD;
-
-        else
-          m_cpt_trt_unused++;
-      }
-      else
-        m_cpt_read_fsm_trt_used++;
-      break;
-
-    /////////////////////
-    case ALLOC_TRT_WRITE:
-      if((r_write_fsm.read() != WRITE_MISS_TRT_LOCK) and
-          (r_write_fsm.read() != WRITE_BC_TRT_LOCK) and
-          (r_write_fsm.read() != WRITE_BC_IVT_LOCK))
-      {
-        if((r_cas_fsm.read() == CAS_MISS_TRT_LOCK) or
-            (r_cas_fsm.read() == CAS_BC_TRT_LOCK))
-          r_alloc_trt_fsm = ALLOC_TRT_CAS;
-
-        else if((r_xram_rsp_fsm.read()  == XRAM_RSP_DIR_LOCK) and
-                (r_alloc_dir_fsm.read() == ALLOC_DIR_XRAM_RSP))
-          r_alloc_trt_fsm = ALLOC_TRT_XRAM_RSP;
-
-        else if((r_ixr_rsp_fsm.read() == IXR_RSP_TRT_ERASE) or
-                (r_ixr_rsp_fsm.read() == IXR_RSP_TRT_READ))
-          r_alloc_trt_fsm = ALLOC_TRT_IXR_RSP;
-        
-        else if (r_cleanup_fsm.read() == CLEANUP_IXR_REQ)
-          r_alloc_trt_fsm = ALLOC_TRT_CLEANUP;
-        
-        else if (r_ixr_cmd_fsm.read() == IXR_CMD_TRT_LOCK)
-          r_alloc_trt_fsm = ALLOC_TRT_IXR_CMD;
-
-        else if(r_read_fsm.read() == READ_TRT_LOCK)
-          r_alloc_trt_fsm = ALLOC_TRT_READ;
-
-        else
-          m_cpt_trt_unused++;
-      }
-      else
-        m_cpt_write_fsm_trt_used++;
-      break;
-
-    ////////////////////
-    case ALLOC_TRT_CAS:
-      if((r_cas_fsm.read() != CAS_MISS_TRT_LOCK) and
-          (r_cas_fsm.read() != CAS_BC_TRT_LOCK) and
-          (r_cas_fsm.read() != CAS_BC_IVT_LOCK))
-      {
-        if((r_xram_rsp_fsm.read()  == XRAM_RSP_DIR_LOCK) and
             (r_alloc_dir_fsm.read() == ALLOC_DIR_XRAM_RSP))
           r_alloc_trt_fsm = ALLOC_TRT_XRAM_RSP;
 
         else if((r_ixr_rsp_fsm.read() == IXR_RSP_TRT_ERASE) or
-                (r_ixr_rsp_fsm.read() == IXR_RSP_TRT_READ))
-          r_alloc_trt_fsm = ALLOC_TRT_IXR_RSP;
-        
-        else if (r_cleanup_fsm.read() == CLEANUP_IXR_REQ)
-          r_alloc_trt_fsm = ALLOC_TRT_CLEANUP;
-        
-        else if (r_ixr_cmd_fsm.read() == IXR_CMD_TRT_LOCK)
-          r_alloc_trt_fsm = ALLOC_TRT_IXR_CMD;
-
-        else if(r_read_fsm.read() == READ_TRT_LOCK)
-          r_alloc_trt_fsm = ALLOC_TRT_READ;
-
-        else if((r_write_fsm.read() == WRITE_MISS_TRT_LOCK) or
-                (r_write_fsm.read() == WRITE_BC_TRT_LOCK))
-          r_alloc_trt_fsm = ALLOC_TRT_WRITE;
-
-        else
-          m_cpt_trt_unused++;
-      }
-      else
-        m_cpt_cas_fsm_trt_used++;
-      break;
-
-    ////////////////////////
-    case ALLOC_TRT_XRAM_RSP:
-      if(((r_xram_rsp_fsm.read()  != XRAM_RSP_DIR_LOCK)  or
-          (r_alloc_dir_fsm.read() != ALLOC_DIR_XRAM_RSP)) and
-          (r_xram_rsp_fsm.read()  != XRAM_RSP_TRT_COPY)  and
-          (r_xram_rsp_fsm.read()  != XRAM_RSP_DIR_UPDT)  and
-          (r_xram_rsp_fsm.read()  != XRAM_RSP_INVAL_LOCK))
-      {
-        if((r_ixr_rsp_fsm.read() == IXR_RSP_TRT_ERASE) or
             (r_ixr_rsp_fsm.read() == IXR_RSP_TRT_READ))
           r_alloc_trt_fsm = ALLOC_TRT_IXR_RSP;
-        
-        else if (r_cleanup_fsm.read() == CLEANUP_IXR_REQ)
-          r_alloc_trt_fsm = ALLOC_TRT_CLEANUP;
-        
-        else if (r_ixr_cmd_fsm.read() == IXR_CMD_TRT_LOCK)
-          r_alloc_trt_fsm = ALLOC_TRT_IXR_CMD;
-
-        else if(r_read_fsm.read() == READ_TRT_LOCK)
-          r_alloc_trt_fsm = ALLOC_TRT_READ;
-
-        else if((r_write_fsm.read() == WRITE_MISS_TRT_LOCK) or
-                (r_write_fsm.read() == WRITE_BC_TRT_LOCK))
-          r_alloc_trt_fsm = ALLOC_TRT_WRITE;
-
-        else if((r_cas_fsm.read() == CAS_MISS_TRT_LOCK) or
-                (r_cas_fsm.read() == CAS_BC_TRT_LOCK))
-          r_alloc_trt_fsm = ALLOC_TRT_CAS;
-
-        else
-          m_cpt_trt_unused++;
-      }
-      else
-        m_cpt_xram_rsp_fsm_trt_used++;
+              
+        else if( r_config_fsm.read() == CONFIG_TRT_LOCK ) 
+                  r_alloc_trt_fsm = ALLOC_TRT_CONFIG;
+      }
       break;
 
-    ////////////////////////
-    case ALLOC_TRT_IXR_RSP:
-      if((r_ixr_rsp_fsm.read() != IXR_RSP_TRT_ERASE) and
-          (r_ixr_rsp_fsm.read() != IXR_RSP_TRT_READ))
-      {
-        
-        if (r_cleanup_fsm.read() == CLEANUP_IXR_REQ)
-          r_alloc_trt_fsm = ALLOC_TRT_CLEANUP;
-        
-        else if (r_ixr_cmd_fsm.read() == IXR_CMD_TRT_LOCK)
-          r_alloc_trt_fsm = ALLOC_TRT_IXR_CMD;
-
-        else if(r_read_fsm.read() == READ_TRT_LOCK)
-          r_alloc_trt_fsm = ALLOC_TRT_READ;
-
-        else if((r_write_fsm.read() == WRITE_MISS_TRT_LOCK) ||
-                (r_write_fsm.read() == WRITE_BC_TRT_LOCK))
-          r_alloc_trt_fsm = ALLOC_TRT_WRITE;
-
-        else if((r_cas_fsm.read() == CAS_MISS_TRT_LOCK) ||
-                (r_cas_fsm.read() == CAS_BC_TRT_LOCK))
-          r_alloc_trt_fsm = ALLOC_TRT_CAS;
-
-        else if((r_xram_rsp_fsm.read()  == XRAM_RSP_DIR_LOCK) &&
-                (r_alloc_dir_fsm.read() == ALLOC_DIR_XRAM_RSP))
-          r_alloc_trt_fsm = ALLOC_TRT_XRAM_RSP;
-
-        else
-          m_cpt_trt_unused++;
-      }
-      else
-        m_cpt_ixr_fsm_trt_used++;
-      break;
-
-      ////////////////////////
-    case ALLOC_TRT_CLEANUP:
-      if(r_cleanup_fsm.read() != CLEANUP_IXR_REQ)
-      {
-        if (r_ixr_cmd_fsm.read() == IXR_CMD_TRT_LOCK)
-          r_alloc_trt_fsm = ALLOC_TRT_IXR_CMD;
-        
-        else if(r_read_fsm.read() == READ_TRT_LOCK)
-          r_alloc_trt_fsm = ALLOC_TRT_READ;
-
-        else if((r_write_fsm.read() == WRITE_MISS_TRT_LOCK) or
-                (r_write_fsm.read() == WRITE_BC_TRT_LOCK))
-          r_alloc_trt_fsm = ALLOC_TRT_WRITE;
-
-        else if((r_cas_fsm.read() == CAS_MISS_TRT_LOCK) or
-                (r_cas_fsm.read() == CAS_BC_TRT_LOCK))
-          r_alloc_trt_fsm = ALLOC_TRT_CAS;
-
-        else if((r_xram_rsp_fsm.read()  == XRAM_RSP_DIR_LOCK) and
-                (r_alloc_dir_fsm.read() == ALLOC_DIR_XRAM_RSP))
-          r_alloc_trt_fsm = ALLOC_TRT_XRAM_RSP;
-
-        else if((r_ixr_rsp_fsm.read() == IXR_RSP_TRT_ERASE) ||
-            (r_ixr_rsp_fsm.read() == IXR_RSP_TRT_READ))
-          r_alloc_trt_fsm = ALLOC_TRT_IXR_RSP;
-      }
-      break;
-
-      ////////////////////////
-    case ALLOC_TRT_IXR_CMD:
-      if(r_ixr_cmd_fsm.read() != IXR_CMD_TRT_LOCK)
-      {
-        if(r_read_fsm.read() == READ_TRT_LOCK)
-          r_alloc_trt_fsm = ALLOC_TRT_READ;
-
-        else if((r_write_fsm.read() == WRITE_MISS_TRT_LOCK) or
-                (r_write_fsm.read() == WRITE_BC_TRT_LOCK))
-          r_alloc_trt_fsm = ALLOC_TRT_WRITE;
-
-        else if((r_cas_fsm.read() == CAS_MISS_TRT_LOCK) or
-                (r_cas_fsm.read() == CAS_BC_TRT_LOCK))
-          r_alloc_trt_fsm = ALLOC_TRT_CAS;
-
-        else if((r_xram_rsp_fsm.read()  == XRAM_RSP_DIR_LOCK) and
-                (r_alloc_dir_fsm.read() == ALLOC_DIR_XRAM_RSP))
-          r_alloc_trt_fsm = ALLOC_TRT_XRAM_RSP;
-
-        else if((r_ixr_rsp_fsm.read() == IXR_RSP_TRT_ERASE) ||
-            (r_ixr_rsp_fsm.read() == IXR_RSP_TRT_READ))
-          r_alloc_trt_fsm = ALLOC_TRT_IXR_RSP;
-        
-        else if (r_cleanup_fsm.read() == CLEANUP_IXR_REQ)
-          r_alloc_trt_fsm = ALLOC_TRT_CLEANUP;
-      }
-      break;
+
   } // end switch alloc_trt_fsm
 
@@ -8164,4 +8031,6 @@
   /////////////////////////////////////////////////////////////////////////////////////
 
+//std::cout << std::endl << "alloc_heap_fsm" << std::endl;
+
   switch(r_alloc_heap_fsm.read())
   {
@@ -8342,4 +8211,6 @@
 
   } // end switch alloc_heap_fsm
+
+//std::cout << std::endl << "fifo_update" << std::endl;
 
   /////////////////////////////////////////////////////////////////////
@@ -8435,12 +8306,10 @@
   ////////////////////////////////////////////////////////////////////////////////////
 
-  m_write_to_cc_send_inst_fifo.update( write_to_cc_send_fifo_get, write_to_cc_send_fifo_put,
+  m_write_to_cc_send_inst_fifo.update( write_to_cc_send_fifo_get, 
+                                       write_to_cc_send_fifo_put,
                                        write_to_cc_send_fifo_inst );
-  m_write_to_cc_send_srcid_fifo.update( write_to_cc_send_fifo_get, write_to_cc_send_fifo_put,
+  m_write_to_cc_send_srcid_fifo.update( write_to_cc_send_fifo_get, 
+                                        write_to_cc_send_fifo_put,
                                         write_to_cc_send_fifo_srcid );
-#if L1_MULTI_CACHE
-  m_write_to_cc_send_cache_id_fifo.update( write_to_cc_send_fifo_get, write_to_cc_send_fifo_put,
-                                           write_to_cc_send_fifo_cache_id );
-#endif
 
   ////////////////////////////////////////////////////////////////////////////////////
@@ -8448,12 +8317,10 @@
   ////////////////////////////////////////////////////////////////////////////////////
 
-  m_config_to_cc_send_inst_fifo.update( config_to_cc_send_fifo_get, config_to_cc_send_fifo_put,
+  m_config_to_cc_send_inst_fifo.update( config_to_cc_send_fifo_get, 
+                                        config_to_cc_send_fifo_put,
                                         config_to_cc_send_fifo_inst );
-  m_config_to_cc_send_srcid_fifo.update( config_to_cc_send_fifo_get, config_to_cc_send_fifo_put,
+  m_config_to_cc_send_srcid_fifo.update( config_to_cc_send_fifo_get, 
+                                         config_to_cc_send_fifo_put,
                                          config_to_cc_send_fifo_srcid );
-#if L1_MULTI_CACHE
-  m_config_to_cc_send_cache_id_fifo.update( config_to_cc_send_fifo_get, config_to_cc_send_fifo_put,
-                                            config_to_cc_send_fifo_cache_id );
-#endif
 
   ////////////////////////////////////////////////////////////////////////////////////
@@ -8461,12 +8328,10 @@
   ////////////////////////////////////////////////////////////////////////////////////
 
-  m_xram_rsp_to_cc_send_inst_fifo.update( xram_rsp_to_cc_send_fifo_get, xram_rsp_to_cc_send_fifo_put,
+  m_xram_rsp_to_cc_send_inst_fifo.update( xram_rsp_to_cc_send_fifo_get, 
+                                          xram_rsp_to_cc_send_fifo_put,
                                           xram_rsp_to_cc_send_fifo_inst );
-  m_xram_rsp_to_cc_send_srcid_fifo.update( xram_rsp_to_cc_send_fifo_get, xram_rsp_to_cc_send_fifo_put,
+  m_xram_rsp_to_cc_send_srcid_fifo.update( xram_rsp_to_cc_send_fifo_get, 
+                                           xram_rsp_to_cc_send_fifo_put,
                                            xram_rsp_to_cc_send_fifo_srcid );
-#if L1_MULTI_CACHE
-  m_xram_rsp_to_cc_send_cache_id_fifo.update( xram_rsp_to_cc_send_fifo_get, xram_rsp_to_cc_send_fifo_put,
-                                              xram_rsp_to_cc_send_fifo_cache_id );
-#endif
 
   ////////////////////////////////////////////////////////////////////////////////////
@@ -8474,13 +8339,10 @@
   ////////////////////////////////////////////////////////////////////////////////////
 
-  m_cas_to_cc_send_inst_fifo.update( cas_to_cc_send_fifo_get, cas_to_cc_send_fifo_put,
+  m_cas_to_cc_send_inst_fifo.update( cas_to_cc_send_fifo_get, 
+                                     cas_to_cc_send_fifo_put,
                                      cas_to_cc_send_fifo_inst );
-  m_cas_to_cc_send_srcid_fifo.update( cas_to_cc_send_fifo_get, cas_to_cc_send_fifo_put,
+  m_cas_to_cc_send_srcid_fifo.update( cas_to_cc_send_fifo_get, 
+                                      cas_to_cc_send_fifo_put,
                                       cas_to_cc_send_fifo_srcid );
-#if L1_MULTI_CACHE
-  m_cas_to_cc_send_cache_id_fifo.update( cas_to_cc_send_fifo_get, cas_to_cc_send_fifo_put,
-                                         cas_to_cc_send_fifo_cache_id );
-#endif
-
   m_cpt_cycles++;
 
@@ -8495,7 +8357,20 @@
   ////////////////////////////////////////////////////////////
 
-  p_vci_ixr.be      = 0xFF;   // nor transmited to external ram
+  // DATA width is 8 bytes
+  // The following values are not transmitted to XRAM
+  //   p_vci_ixr.be 
+  //   p_vci_ixr.pktid  
+  //   p_vci_ixr.cons 
+  //   p_vci_ixr.wrap 
+  //   p_vci_ixr.contig 
+  //   p_vci_ixr.clen 
+  //   p_vci_ixr.cfixed 
+
+  p_vci_ixr.plen    = 64;
+  p_vci_ixr.srcid   = m_srcid_x;
+  p_vci_ixr.trdid   = r_ixr_cmd_trdid.read();
+  p_vci_ixr.address = (addr_t)r_ixr_cmd_address.read() + (r_ixr_cmd_word.read()<<2);
+  p_vci_ixr.be      = 0xFF; 
   p_vci_ixr.pktid   = 0;
-  p_vci_ixr.srcid   = m_srcid_x;
   p_vci_ixr.cons    = false;
   p_vci_ixr.wrap    = false;
